interface AsyncLoopProgression {
    index: number;
    totalExecutionCount: number;
    params: any;
    currentExecutionCount: number;
}
interface AsyncLoopProgressionStop<RETURN_TYPE> extends AsyncLoopProgression {
    result: RETURN_TYPE;
}
type AsyncLoopProgressionOnStart = (data: AsyncLoopProgression) => void;
type AsyncLoopProgressionOnStop<RETURN_TYPE> = (data: AsyncLoopProgressionStop<RETURN_TYPE>) => void;
interface MakeAsyncLoopOptions<RETURN_TYPE> {
    waitingDuration?: number;
    maxExecution?: number;
    onStart?: AsyncLoopProgressionOnStart;
    onStop?: AsyncLoopProgressionOnStop<RETURN_TYPE>;
}

declare const makeAsyncLoop: <RETURN_TYPE>(callback: (...parameters: any[]) => Promise<RETURN_TYPE>, options?: MakeAsyncLoopOptions<RETURN_TYPE> | undefined) => (...parameters: any[]) => Promise<RETURN_TYPE[]>;

declare class AsynLoopError extends Error {
    error: any;
    index: number;
    params: any;
    currentExecutionCount: number;
    totalExecutionCount: number;
    constructor(error: any, index: number, params: any, currentExecutionCount: number, totalExecutionCount: number);
}
declare const isAsynLoopError: (error: any) => error is AsynLoopError;

export { AsynLoopError, type AsyncLoopProgression, type AsyncLoopProgressionOnStart, type AsyncLoopProgressionOnStop, type AsyncLoopProgressionStop, type MakeAsyncLoopOptions, isAsynLoopError, makeAsyncLoop };
